#!/bin/bash
CORE=core
OUT=core.uninit
SOURCE=crash.c
BIN=./crash

function prep_bin() {
  [ -f "$BIN" ] && return
  cat > $SOURCE <<@@@
int main() {
  volatile char *c = 0;
  (void)*c;
  return 0;
}
@@@
  gcc $SOURCE -o $BIN || exit 1
}

function do_dd() {
  dd if=$CORE of=$OUT ibs=1 obs=1 skip=$1 count=$2 oflag=append conv=notrunc 2>/dev/null
}

prep_bin
ulimit -c 10000
$BIN |:
rm -f $OUT
do_dd 2412 24
do_dd 2444 128
do_dd 2828 48
do_dd 2988 2112

strings $OUT
rm -f $OUT $CORE
